close all
clc
clear
format compact

display('running sat_sat.m')
%these are for the satellite - sat link
c = 299792458; %m/s
k = 1.39e-23; %J/K Boltzmann's constant

%these scripts perform calculations required for these links
run distances
run modulation

%only need link budget one way since they are symetric
freq = 6e9 ;%Ghz;
lambda = c/freq;
freqlimit = (freq + BW/2)/1e9
freqlimt = (freq -BW/2)/1e9

display('These are the link calcs from Sat to Sat')

%for satellite -------------

%calculate EIRP for sat
Pt = [1:100];
G_ant = 20; %dB
r_sat_ant = ((((10^(G_ant/10))/.8)*(lambda^2))/(4*pi^2))^(1/2)
EIRP = 10*log10(Pt) + G_ant;
beamwidth = sqrt(30000/10^(G_ant/10))

%downlink calc (from sat to term)
Q = 50;
Tsys = 20; %K

Pr = EIRP + G_ant-20*log10(4*pi/lambda*dist_sats);
Pn = 10*log10((k*Tsys*BW) + (10.^(Pr./10)*(Q-1)));

SNR_despread = Pr-Pn + procgain;

%using other simplier coding technigues, 5dB coding gain
SNR_uncoded = SNR_despread+coding_gain;

%using QPSK: 
x = sqrt(2*10.^(SNR_uncoded./10));
BER_downlink = 1/2*erfc(x/sqrt(2));

figure(1), semilogy(Pt, BER_downlink);
 title('Pt of Satellite vs BER')
 xlabel('Pt of Satellite(W)');
 ylabel('BER');
 grid on

indexBER = find(BER_downlink <1e-6, 1, 'first');
Pt = Pt(indexBER)
SNR_uncoded = SNR_uncoded(indexBER)
BER_downlink = BER_downlink(indexBER)
